theory QSpec imports Main begin

text{* Requirement Specification for the Queue *}

typedecl 
  'a q

consts
  mtQ   :: "'a q"
  isEmpty :: "'a q => bool"
  enq     :: "'a => 'a q => 'a q"
  front   :: "'a q => 'a"
  deq     :: "'a q => 'a q"

axiomatization where
    empty: "isEmpty mtQ"
and notEmpty: "~ (isEmpty (enq a q))"
and front_mt: "isEmpty q \<Longrightarrow> front (enq a q) = a"
and front_nonmt: "~ isEmpty q \<Longrightarrow> front (enq a q) = front q"
and deq_mt: "isEmpty q \<Longrightarrow> deq (enq a q) = mtQ"
and deq_nonmt: "\<not> isEmpty q \<Longrightarrow> deq (enq a q) = enq a (deq q)"

end
